<?php

class appWrapProductForGiftHelper
{
    /**
     * 
     * @var Product[]
     */
    protected $products = [];

    protected static $instance;

    public static function getInstance(): appWrapProductForGiftHelper
    {
        if (null === self::$instance)
        {
            self::$instance = new static();
        }

        return self::$instance; 
    }

    public function isEnabled(): bool
    {
        return boolval(stConfig::getInstance('appWrapProductForGiftBackend')->get('enabled'));
    }

    public function get(BasketProduct $basketProduct): ?BasketProduct
    {
        $product = $this->getProduct($basketProduct);

        if ($product)
        {
            $basketGiftWrapProduct = new BasketProduct();
            $basketGiftWrapProduct->setProduct($product);
            $basketGiftWrapProduct->setQuantity($basketProduct->getQuantity());

            return $basketGiftWrapProduct;
        } 

        return null;
    }

    public function getProduct(BasketProduct $basketProduct): ?Product
    {
        $config = stConfig::getInstance('appWrapProductForGiftBackend');
        
        if (null === $basketProduct->getAppWrapProductForGiftId() || !in_array($basketProduct->getAppWrapProductForGiftId(), $config->get('products')))
        {
            return null;
        }

        if (!isset($this->products[$basketProduct->getAppWrapProductForGiftId()]) && !array_key_exists($basketProduct->getAppWrapProductForGiftId(), $this->products))
        {
            $this->products[$basketProduct->getAppWrapProductForGiftId()] = ProductPeer::retrieveByPK($basketProduct->getAppWrapProductForGiftId());
        }

        return $this->products[$basketProduct->getAppWrapProductForGiftId()];
    }
}