<?php


class appWrapProductForGiftFrontendActions extends stActions
{
    public function executeChoose()
    {
        /**
         * @var stBasket $basket
         */
        $basket = $this->getUser()->getBasket();
        $config = stConfig::getInstance('appWrapProductForGiftBackend');
        $request = $this->getRequest();
        $item = $basket->getItem($request->getParameter('basket_item_id'));
        $wrapGiftProduct = appWrapProductForGiftHelper::getInstance()->getProduct($item);

        if ($request->getMethod() == sfRequest::POST)
        {
            $item->setAppWrapProductForGiftId($request->getParameter('selected'));
            $item->setAppWrapProductForGiftMessage($request->getParameter('message'));
            $item->save();

            return $this->renderJSON([
                'status' => 'OK',
            ]);
        }

        $c = new Criteria();
        $c->add(ProductPeer::ID, $config->get('products'), Criteria::IN);
        ProductPeer::addFilterCriteria($this->getContext(), $c, false);
        $c->remove(ProductPeer::ACTIVE);
        $products = ProductPeer::doSelect($c);

        $smarty = new stSmarty('appWrapProductForGiftFrontend');
        $smarty->assign('products', $products);
        $smarty->assign('config', $config);
        $smarty->assign('basket_item', $item);
        $smarty->assign('selected', $wrapGiftProduct ? $wrapGiftProduct->getId() : null);
        $smarty->assign('simple_layout', 1 == count($products));

        $this->smarty = $smarty;
        $this->setLayout(false);
    }
}
