<?php
 

class appWrapProductForGiftFrontendComponents extends sfComponents
{
    public function executeRenderBasketItemRow()
    {
        /**
         * @var BasketProduct $basketProduct
         */
        $basketProduct = $this->product['instance'];

        if ($basketProduct->getProduct()->getAppWrapProductForGiftIsExcluded())
        {
            return sfView::NONE;
        }

        $smarty = new stSmarty('appWrapProductForGiftFrontend');
        $smarty->assign('basket_product', $basketProduct);
        $smarty->assign('show', $this->show);
        $smarty->assign('gift_wrap_helper', appWrapProductForGiftHelper::getInstance());
        return $smarty;
    }

    public function executeRenderBasketWidgetItemRow()
    {
        /**
         * @var BasketProduct $basketProduct
         */
        $basketProduct = $this->item['instance'];

        if ($basketProduct->getProduct()->getAppWrapProductForGiftIsExcluded() || null === $basketProduct->getAppWrapProductForGiftId())
        {
            return sfView::NONE;
        }

        $smarty = new stSmarty('appWrapProductForGiftFrontend');
        $smarty->assign('basket_product', $basketProduct);
        $smarty->assign('gift_wrap_helper', appWrapProductForGiftHelper::getInstance());
        return $smarty;
    }

    public function executeRenderOrderItemRow()
    {
        /**
         * @var BasketProduct $basketProduct
         */
        $basketProduct = $this->product['instance'];
        
        if (null === $basketProduct->getAppWrapProductForGiftId())
        {
            return sfView::NONE;
        }

        $smarty = new stSmarty('appWrapProductForGiftFrontend');
        $smarty->assign('basket_product', $basketProduct);
        $smarty->assign('show', $this->show);
        $smarty->assign('gift_wrap_helper', appWrapProductForGiftHelper::getInstance());
        return $smarty;
    }

    public function executeRenderBasketModal()
    {
        $smarty = new stSmarty('appWrapProductForGiftFrontend');
        return $smarty;
    }
}