jQuery(function($) {
    const modal = $('#app-wrap-product-for-gift-basket-modal');
    const url = modal.data('url');
    let currentItemRow = null;
  
    modal.on('hide.bs.modal', function(e) {
        if (!modal.find('.selected-gift-wrap').val()) {
            currentItemRow.find('.app-wrap-product-for-gift-checkbox').prop('checked', false);
        }
    });

    modal.on('show.bs.modal', function() {
        const preloader = modal.find('.preloader');
        const body = modal.find('.modal-body');
        const submit = modal.find('[data-submit]');

        submit.click(function() {
            modal.find('form').submit();
        });

        body.html('');
        preloader.show();

        $.get(url, {'basket_item_id': currentItemRow.data('item-id')}, function(response) {
            body.html(response);
            preloader.hide();

            const totalAmount = body.find('.total-amount');
            const textMessage = body.find('.text-message textarea');
            const textMessageChairsLeft = body.find('.text-message-chars-left');
            const selected = body.find('.selected-gift-wrap');
            const products = modal.find('.product').click(function() {
                const product = $(this);

                products.removeClass('selected');
                product.addClass('selected');

                selected.val(product.data('id'));

                totalAmount.html(product.data('price'));
            });

            const form = body.find('form').submit(function() {
                preloader.show();
                
                $.post(form.prop('action'), form.serialize(), function() {
                    window.location.reload();
                });

                return false;
            });

            textMessage.keyup(function() {
                textMessageChairsLeft.html(textMessageChairsLeft.data('text').replace('%%left%%', textMessage.prop('maxlength') - textMessage.val().length));
            }).keyup();

            if (!selected.val()) {
                products.first().click();
            } else {
                products.filter('[data-id='+selected.val()+']').click();
            }
        });
    });

    $('.app-wrap-product-for-gift-row').each(function() {
        const row = $(this);
        row.prev().addClass('app-wrap-product-for-gift-item-row');
    }).on('change', '.app-wrap-product-for-gift-checkbox', function() {
        const checkbox = $(this);
        currentItemRow = checkbox.closest('tr');

        if (checkbox.prop('checked')) {
            modal.modal('show');
        } else {
            $('#basket-update-modal').modal('show');
            $.post(url, {'basket_item_id': currentItemRow.data('item-id')}, function() {
                window.location.reload();
            });
        }
    }).on('click', '.app-wrap-product-for-gift-choose', function() {
        currentItemRow = $(this).closest('tr');
        modal.modal('show');
        return false;
    });
});